From 27f6a36259ffc4386513d1d78ebf95aeee59d698 Mon Sep 17 00:00:00 2001
From: David Vossel <davidvossel@gmail.com>
Date: Mon, 24 Jan 2022 16:20:02 -0500
Subject: [PATCH 2/2] Switch to semantic DeepEquals()

Signed-off-by: David Vossel <davidvossel@gmail.com>
---
 pkg/controller/BUILD.bazel                    |  1 +
 pkg/controller/controller_ref_manager_test.go |  6 ++--
 pkg/hooks/BUILD.bazel                         |  1 +
 pkg/hooks/hooks_test.go                       |  5 ++-
 pkg/util/status/BUILD.bazel                   |  1 +
 pkg/util/status/status.go                     |  6 ++--
 pkg/virt-api/rest/BUILD.bazel                 |  1 +
 pkg/virt-api/rest/subresource.go              |  4 +--
 .../mutating-webhook/mutators/BUILD.bazel     |  2 ++
 .../mutating-webhook/mutators/preset.go       | 32 +++++++++----------
 .../mutating-webhook/mutators/vmi-mutator.go  |  4 +--
 .../mutators/vmi-mutator_test.go              | 10 +++---
 .../validating-webhook/admitters/BUILD.bazel  |  2 ++
 .../admitters/migration-update-admitter.go    |  5 ++-
 .../admitters/vmi-update-admitter.go          | 14 ++++----
 .../admitters/vmi-update-admitter_test.go     |  8 ++---
 .../admitters/vmpool-admitter.go              |  4 +--
 .../admitters/vmrestore-admitter.go           |  6 ++--
 .../admitters/vms-admitter.go                 | 10 +++---
 .../admitters/vmsnapshot-admitter.go          |  4 +--
 pkg/virt-controller/watch/BUILD.bazel         |  2 ++
 .../watch/drain/disruptionbudget/BUILD.bazel  |  1 +
 .../disruptionbudget/disruptionbudget.go      |  6 ++--
 pkg/virt-controller/watch/migration.go        | 18 +++++------
 pkg/virt-controller/watch/migration_test.go   |  2 ++
 pkg/virt-controller/watch/pool.go             |  8 ++---
 pkg/virt-controller/watch/replicaset.go       |  6 ++--
 .../watch/snapshot/BUILD.bazel                |  1 +
 pkg/virt-controller/watch/snapshot/restore.go |  8 ++---
 .../watch/snapshot/snapshot.go                |  6 ++--
 .../watch/topology/BUILD.bazel                |  1 +
 .../watch/topology/nodetopologyupdater.go     |  4 +--
 pkg/virt-controller/watch/vm.go               | 16 +++++-----
 pkg/virt-controller/watch/vmi.go              | 18 +++++------
 pkg/virt-controller/watch/vmi_test.go         | 12 +++----
 pkg/virt-handler/cache/BUILD.bazel            |  1 +
 pkg/virt-handler/cache/cache_test.go          |  4 +--
 pkg/virt-handler/container-disk/BUILD.bazel   |  1 +
 pkg/virt-handler/container-disk/mount.go      |  4 +--
 pkg/virt-handler/node-labeller/BUILD.bazel    |  1 +
 .../node-labeller/node_labeller.go            |  6 ++--
 pkg/virt-launcher/notify-client/BUILD.bazel   |  1 +
 .../notify-client/notify_test.go              | 10 +++---
 .../virtwrap/agent-poller/BUILD.bazel         |  1 +
 .../virtwrap/agent-poller/agent_poller.go     |  4 +--
 .../virtwrap/converter/BUILD.bazel            |  1 +
 .../virtwrap/converter/converter_test.go      |  6 ++--
 .../virtwrap/statsconv/BUILD.bazel            |  1 +
 .../virtwrap/statsconv/converter_test.go      |  4 +--
 pkg/virt-operator/BUILD.bazel                 |  1 +
 pkg/virt-operator/kubevirt.go                 |  6 ++--
 pkg/virt-operator/resource/apply/BUILD.bazel  |  1 +
 pkg/virt-operator/resource/apply/apps_test.go | 10 +++---
 pkg/virt-operator/resource/apply/core.go      |  3 +-
 .../resource/apply/reconcile_test.go          | 10 +++---
 .../resource/generate/install/BUILD.bazel     |  1 +
 .../generate/install/strategy_test.go         | 22 ++++++-------
 pkg/virt-operator/webhooks/BUILD.bazel        |  1 +
 .../webhooks/kubevirt-update-admitter.go      |  6 ++--
 tests/BUILD.bazel                             |  1 +
 tests/utils.go                                |  3 +-
 61 files changed, 185 insertions(+), 160 deletions(-)

diff --git a/pkg/controller/BUILD.bazel b/pkg/controller/BUILD.bazel
index 1fd084aed..e6f5e6634 100644
--- a/pkg/controller/BUILD.bazel
+++ b/pkg/controller/BUILD.bazel
@@ -76,6 +76,7 @@ go_test(
         "//vendor/github.com/onsi/gomega:go_default_library",
         "//vendor/k8s.io/api/core/v1:go_default_library",
         "//vendor/k8s.io/api/extensions/v1beta1:go_default_library",
+        "//vendor/k8s.io/apimachinery/pkg/api/equality:go_default_library",
         "//vendor/k8s.io/apimachinery/pkg/apis/meta/v1:go_default_library",
         "//vendor/k8s.io/apimachinery/pkg/labels:go_default_library",
         "//vendor/k8s.io/apimachinery/pkg/runtime/schema:go_default_library",
diff --git a/pkg/controller/controller_ref_manager_test.go b/pkg/controller/controller_ref_manager_test.go
index 132b3f80a..7864a8fe5 100644
--- a/pkg/controller/controller_ref_manager_test.go
+++ b/pkg/controller/controller_ref_manager_test.go
@@ -18,12 +18,12 @@ limitations under the License.
 package controller
 
 import (
-	"reflect"
 	"sync"
 	"testing"
 
 	v1 "k8s.io/api/core/v1"
 	"k8s.io/api/extensions/v1beta1"
+	"k8s.io/apimachinery/pkg/api/equality"
 	metav1 "k8s.io/apimachinery/pkg/apis/meta/v1"
 	"k8s.io/apimachinery/pkg/labels"
 	"k8s.io/apimachinery/pkg/runtime/schema"
@@ -178,7 +178,7 @@ func TestClaimVirtualMachineInstance(t *testing.T) {
 		claimed, err := test.manager.ClaimVirtualMachineInstances(test.virtualmachines)
 		if test.expectError && err == nil {
 			t.Errorf("Test case `%s`, expected error but got nil", test.name)
-		} else if !reflect.DeepEqual(test.claimed, claimed) {
+		} else if !equality.Semantic.DeepEqual(test.claimed, claimed) {
 			t.Errorf("Test case `%s`, claimed wrong virtualmachines. Expected %v, got %v", test.name, virtualmachineToStringSlice(test.claimed), virtualmachineToStringSlice(claimed))
 		}
 
@@ -284,7 +284,7 @@ func TestClaimDataVolume(t *testing.T) {
 		claimed, err := test.manager.ClaimMatchedDataVolumes(test.datavolumes)
 		if test.expectError && err == nil {
 			t.Errorf("Test case `%s`, expected error but got nil", test.name)
-		} else if !reflect.DeepEqual(test.claimed, claimed) {
+		} else if !equality.Semantic.DeepEqual(test.claimed, claimed) {
 			t.Errorf("Test case `%s`, claimed wrong datavolumes. Expected %v, got %v", test.name, datavolumeToStringSlice(test.claimed), datavolumeToStringSlice(claimed))
 		}
 
diff --git a/pkg/hooks/BUILD.bazel b/pkg/hooks/BUILD.bazel
index 51c440c5e..903217ee7 100644
--- a/pkg/hooks/BUILD.bazel
+++ b/pkg/hooks/BUILD.bazel
@@ -36,6 +36,7 @@ go_test(
         "//staging/src/kubevirt.io/client-go/testutils:go_default_library",
         "//vendor/github.com/onsi/ginkgo:go_default_library",
         "//vendor/github.com/onsi/gomega:go_default_library",
+        "//vendor/k8s.io/apimachinery/pkg/api/equality:go_default_library",
         "//vendor/k8s.io/apimachinery/pkg/apis/meta/v1:go_default_library",
         "@org_golang_google_grpc//:go_default_library",
     ],
diff --git a/pkg/hooks/hooks_test.go b/pkg/hooks/hooks_test.go
index f52c2b21a..b964509a7 100644
--- a/pkg/hooks/hooks_test.go
+++ b/pkg/hooks/hooks_test.go
@@ -20,10 +20,9 @@
 package hooks_test
 
 import (
-	"reflect"
-
 	. "github.com/onsi/ginkgo"
 	. "github.com/onsi/gomega"
+	"k8s.io/apimachinery/pkg/api/equality"
 	metav1 "k8s.io/apimachinery/pkg/apis/meta/v1"
 
 	v1 "kubevirt.io/api/core/v1"
@@ -63,7 +62,7 @@ var _ = Describe("HooksAPI", func() {
 			}
 			hookSidecarList, err := hooks.UnmarshalHookSidecarList(vmiHookObject)
 			Expect(err).ToNot(HaveOccurred())
-			Expect(reflect.DeepEqual(hookSidecarList, expectedHookSidecarList)).To(BeTrue())
+			Expect(equality.Semantic.DeepEqual(hookSidecarList, expectedHookSidecarList)).To(BeTrue())
 		})
 	})
 })
diff --git a/pkg/util/status/BUILD.bazel b/pkg/util/status/BUILD.bazel
index b434ee005..2ab558ac7 100644
--- a/pkg/util/status/BUILD.bazel
+++ b/pkg/util/status/BUILD.bazel
@@ -8,6 +8,7 @@ go_library(
     deps = [
         "//staging/src/kubevirt.io/api/core/v1:go_default_library",
         "//staging/src/kubevirt.io/client-go/kubecli:go_default_library",
+        "//vendor/k8s.io/apimachinery/pkg/api/equality:go_default_library",
         "//vendor/k8s.io/apimachinery/pkg/api/errors:go_default_library",
         "//vendor/k8s.io/apimachinery/pkg/api/meta:go_default_library",
         "//vendor/k8s.io/apimachinery/pkg/apis/meta/v1:go_default_library",
diff --git a/pkg/util/status/status.go b/pkg/util/status/status.go
index faacc50e4..dc86dd885 100644
--- a/pkg/util/status/status.go
+++ b/pkg/util/status/status.go
@@ -1,9 +1,9 @@
 package status
 
 import (
-	"reflect"
 	"sync"
 
+	"k8s.io/apimachinery/pkg/api/equality"
 	"k8s.io/apimachinery/pkg/api/errors"
 	"k8s.io/apimachinery/pkg/api/meta"
 	"k8s.io/apimachinery/pkg/runtime"
@@ -49,7 +49,7 @@ func (u *updater) updateWithoutSubresource(obj runtime.Object) (err error) {
 	if err != nil {
 		return err
 	}
-	if !reflect.DeepEqual(oldStatus, newStatus) {
+	if !equality.Semantic.DeepEqual(oldStatus, newStatus) {
 		u.setSubresource(true)
 		return u.updateStatusUnstructured(obj)
 	}
@@ -70,7 +70,7 @@ func (u *updater) updateWithSubresource(obj runtime.Object) (updateStatusErr err
 			// object does not exist
 			return err
 		}
-		if err == nil && reflect.DeepEqual(oldStatus, newStatus) {
+		if err == nil && equality.Semantic.DeepEqual(oldStatus, newStatus) {
 			u.setSubresource(false)
 		} else if err == nil {
 			return updateStatusErr
diff --git a/pkg/virt-api/rest/BUILD.bazel b/pkg/virt-api/rest/BUILD.bazel
index 52a65c90d..6fba3ea53 100644
--- a/pkg/virt-api/rest/BUILD.bazel
+++ b/pkg/virt-api/rest/BUILD.bazel
@@ -37,6 +37,7 @@ go_library(
         "//vendor/github.com/gorilla/websocket:go_default_library",
         "//vendor/k8s.io/api/authorization/v1:go_default_library",
         "//vendor/k8s.io/api/core/v1:go_default_library",
+        "//vendor/k8s.io/apimachinery/pkg/api/equality:go_default_library",
         "//vendor/k8s.io/apimachinery/pkg/api/errors:go_default_library",
         "//vendor/k8s.io/apimachinery/pkg/apis/meta/v1:go_default_library",
         "//vendor/k8s.io/apimachinery/pkg/fields:go_default_library",
diff --git a/pkg/virt-api/rest/subresource.go b/pkg/virt-api/rest/subresource.go
index e03d59b88..8d0e562bd 100644
--- a/pkg/virt-api/rest/subresource.go
+++ b/pkg/virt-api/rest/subresource.go
@@ -26,12 +26,12 @@ import (
 	"fmt"
 	"io"
 	"net/http"
-	"reflect"
 	"strings"
 	"sync"
 
 	"github.com/emicklei/go-restful"
 	v12 "k8s.io/api/core/v1"
+	"k8s.io/apimachinery/pkg/api/equality"
 	"k8s.io/apimachinery/pkg/api/errors"
 	k8smetav1 "k8s.io/apimachinery/pkg/apis/meta/v1"
 	"k8s.io/apimachinery/pkg/fields"
@@ -159,7 +159,7 @@ func getChangeRequestJson(vm *v1.VirtualMachine, changes ...v1.VirtualMachineSta
 	verb := "add"
 	// Special case: if there's no status field at all, add one.
 	newStatus := v1.VirtualMachineStatus{}
-	if reflect.DeepEqual(vm.Status, newStatus) {
+	if equality.Semantic.DeepEqual(vm.Status, newStatus) {
 		for _, change := range changes {
 			newStatus.StateChangeRequests = append(newStatus.StateChangeRequests, change)
 		}
diff --git a/pkg/virt-api/webhooks/mutating-webhook/mutators/BUILD.bazel b/pkg/virt-api/webhooks/mutating-webhook/mutators/BUILD.bazel
index 4b32a57a6..810abfa6a 100644
--- a/pkg/virt-api/webhooks/mutating-webhook/mutators/BUILD.bazel
+++ b/pkg/virt-api/webhooks/mutating-webhook/mutators/BUILD.bazel
@@ -22,6 +22,7 @@ go_library(
         "//staging/src/kubevirt.io/client-go/log:go_default_library",
         "//vendor/k8s.io/api/admission/v1:go_default_library",
         "//vendor/k8s.io/api/core/v1:go_default_library",
+        "//vendor/k8s.io/apimachinery/pkg/api/equality:go_default_library",
         "//vendor/k8s.io/apimachinery/pkg/api/resource:go_default_library",
         "//vendor/k8s.io/apimachinery/pkg/apis/meta/v1:go_default_library",
         "//vendor/k8s.io/apimachinery/pkg/labels:go_default_library",
@@ -58,6 +59,7 @@ go_test(
         "//vendor/k8s.io/api/admission/v1:go_default_library",
         "//vendor/k8s.io/api/authentication/v1:go_default_library",
         "//vendor/k8s.io/api/core/v1:go_default_library",
+        "//vendor/k8s.io/apimachinery/pkg/api/equality:go_default_library",
         "//vendor/k8s.io/apimachinery/pkg/api/resource:go_default_library",
         "//vendor/k8s.io/apimachinery/pkg/apis/meta/v1:go_default_library",
         "//vendor/k8s.io/apimachinery/pkg/runtime:go_default_library",
diff --git a/pkg/virt-api/webhooks/mutating-webhook/mutators/preset.go b/pkg/virt-api/webhooks/mutating-webhook/mutators/preset.go
index 75dc3dc30..78d8bd5ef 100644
--- a/pkg/virt-api/webhooks/mutating-webhook/mutators/preset.go
+++ b/pkg/virt-api/webhooks/mutating-webhook/mutators/preset.go
@@ -21,9 +21,9 @@ package mutators
 
 import (
 	"fmt"
-	"reflect"
 
 	k8sv1 "k8s.io/api/core/v1"
+	"k8s.io/apimachinery/pkg/api/equality"
 	k8smetav1 "k8s.io/apimachinery/pkg/apis/meta/v1"
 	"k8s.io/apimachinery/pkg/labels"
 	utilerrors "k8s.io/apimachinery/pkg/util/errors"
@@ -78,37 +78,37 @@ func checkMergeConflicts(presetSpec *kubev1.DomainSpec, vmiSpec *kubev1.DomainSp
 		}
 	}
 	if presetSpec.CPU != nil && vmiSpec.CPU != nil {
-		if !reflect.DeepEqual(presetSpec.CPU, vmiSpec.CPU) {
+		if !equality.Semantic.DeepEqual(presetSpec.CPU, vmiSpec.CPU) {
 			errors = append(errors, fmt.Errorf("spec.cpu: %v != %v", presetSpec.CPU, vmiSpec.CPU))
 		}
 	}
 	if presetSpec.Firmware != nil && vmiSpec.Firmware != nil {
-		if !reflect.DeepEqual(presetSpec.Firmware, vmiSpec.Firmware) {
+		if !equality.Semantic.DeepEqual(presetSpec.Firmware, vmiSpec.Firmware) {
 			errors = append(errors, fmt.Errorf("spec.firmware: %v != %v", presetSpec.Firmware, vmiSpec.Firmware))
 		}
 	}
 	if presetSpec.Clock != nil && vmiSpec.Clock != nil {
-		if !reflect.DeepEqual(presetSpec.Clock.ClockOffset, vmiSpec.Clock.ClockOffset) {
+		if !equality.Semantic.DeepEqual(presetSpec.Clock.ClockOffset, vmiSpec.Clock.ClockOffset) {
 			errors = append(errors, fmt.Errorf("spec.clock.clockoffset: %v != %v", presetSpec.Clock.ClockOffset, vmiSpec.Clock.ClockOffset))
 		}
 		if presetSpec.Clock.Timer != nil && vmiSpec.Clock.Timer != nil {
-			if !reflect.DeepEqual(presetSpec.Clock.Timer, vmiSpec.Clock.Timer) {
+			if !equality.Semantic.DeepEqual(presetSpec.Clock.Timer, vmiSpec.Clock.Timer) {
 				errors = append(errors, fmt.Errorf("spec.clock.timer: %v != %v", presetSpec.Clock.Timer, vmiSpec.Clock.Timer))
 			}
 		}
 	}
 	if presetSpec.Features != nil && vmiSpec.Features != nil {
-		if !reflect.DeepEqual(presetSpec.Features, vmiSpec.Features) {
+		if !equality.Semantic.DeepEqual(presetSpec.Features, vmiSpec.Features) {
 			errors = append(errors, fmt.Errorf("spec.features: %v != %v", presetSpec.Features, vmiSpec.Features))
 		}
 	}
 	if presetSpec.Devices.Watchdog != nil && vmiSpec.Devices.Watchdog != nil {
-		if !reflect.DeepEqual(presetSpec.Devices.Watchdog, vmiSpec.Devices.Watchdog) {
+		if !equality.Semantic.DeepEqual(presetSpec.Devices.Watchdog, vmiSpec.Devices.Watchdog) {
 			errors = append(errors, fmt.Errorf("spec.devices.watchdog: %v != %v", presetSpec.Devices.Watchdog, vmiSpec.Devices.Watchdog))
 		}
 	}
 	if presetSpec.IOThreadsPolicy != nil && vmiSpec.IOThreadsPolicy != nil {
-		if !reflect.DeepEqual(presetSpec.IOThreadsPolicy, vmiSpec.IOThreadsPolicy) {
+		if !equality.Semantic.DeepEqual(presetSpec.IOThreadsPolicy, vmiSpec.IOThreadsPolicy) {
 			errors = append(errors, fmt.Errorf("spec.ioThreadsPolicy: %v != %v", presetSpec.IOThreadsPolicy, vmiSpec.IOThreadsPolicy))
 		}
 	}
@@ -130,7 +130,7 @@ func mergeDomainSpec(presetSpec *kubev1.DomainSpec, vmiSpec *kubev1.DomainSpec)
 				vmiSpec.Resources.Requests[key] = val
 			}
 		}
-		if reflect.DeepEqual(vmiSpec.Resources.Requests, presetSpec.Resources.Requests) {
+		if equality.Semantic.DeepEqual(vmiSpec.Resources.Requests, presetSpec.Resources.Requests) {
 			applied = true
 		}
 	}
@@ -139,7 +139,7 @@ func mergeDomainSpec(presetSpec *kubev1.DomainSpec, vmiSpec *kubev1.DomainSpec)
 			vmiSpec.CPU = &kubev1.CPU{}
 			presetSpec.CPU.DeepCopyInto(vmiSpec.CPU)
 		}
-		if reflect.DeepEqual(vmiSpec.CPU, presetSpec.CPU) {
+		if equality.Semantic.DeepEqual(vmiSpec.CPU, presetSpec.CPU) {
 			applied = true
 		}
 	}
@@ -148,7 +148,7 @@ func mergeDomainSpec(presetSpec *kubev1.DomainSpec, vmiSpec *kubev1.DomainSpec)
 			vmiSpec.Firmware = &kubev1.Firmware{}
 			presetSpec.Firmware.DeepCopyInto(vmiSpec.Firmware)
 		}
-		if reflect.DeepEqual(vmiSpec.Firmware, presetSpec.Firmware) {
+		if equality.Semantic.DeepEqual(vmiSpec.Firmware, presetSpec.Firmware) {
 			applied = true
 		}
 	}
@@ -157,7 +157,7 @@ func mergeDomainSpec(presetSpec *kubev1.DomainSpec, vmiSpec *kubev1.DomainSpec)
 			vmiSpec.Clock = &kubev1.Clock{}
 			vmiSpec.Clock.ClockOffset = presetSpec.Clock.ClockOffset
 		}
-		if reflect.DeepEqual(vmiSpec.Clock, presetSpec.Clock) {
+		if equality.Semantic.DeepEqual(vmiSpec.Clock, presetSpec.Clock) {
 			applied = true
 		}
 
@@ -166,7 +166,7 @@ func mergeDomainSpec(presetSpec *kubev1.DomainSpec, vmiSpec *kubev1.DomainSpec)
 				vmiSpec.Clock.Timer = &kubev1.Timer{}
 				presetSpec.Clock.Timer.DeepCopyInto(vmiSpec.Clock.Timer)
 			}
-			if reflect.DeepEqual(vmiSpec.Clock.Timer, presetSpec.Clock.Timer) {
+			if equality.Semantic.DeepEqual(vmiSpec.Clock.Timer, presetSpec.Clock.Timer) {
 				applied = true
 			}
 		}
@@ -176,7 +176,7 @@ func mergeDomainSpec(presetSpec *kubev1.DomainSpec, vmiSpec *kubev1.DomainSpec)
 			vmiSpec.Features = &kubev1.Features{}
 			presetSpec.Features.DeepCopyInto(vmiSpec.Features)
 		}
-		if reflect.DeepEqual(vmiSpec.Features, presetSpec.Features) {
+		if equality.Semantic.DeepEqual(vmiSpec.Features, presetSpec.Features) {
 			applied = true
 		}
 	}
@@ -185,7 +185,7 @@ func mergeDomainSpec(presetSpec *kubev1.DomainSpec, vmiSpec *kubev1.DomainSpec)
 			vmiSpec.Devices.Watchdog = &kubev1.Watchdog{}
 			presetSpec.Devices.Watchdog.DeepCopyInto(vmiSpec.Devices.Watchdog)
 		}
-		if reflect.DeepEqual(vmiSpec.Devices.Watchdog, presetSpec.Devices.Watchdog) {
+		if equality.Semantic.DeepEqual(vmiSpec.Devices.Watchdog, presetSpec.Devices.Watchdog) {
 			applied = true
 		}
 	}
@@ -194,7 +194,7 @@ func mergeDomainSpec(presetSpec *kubev1.DomainSpec, vmiSpec *kubev1.DomainSpec)
 			ioThreadsPolicy := *presetSpec.IOThreadsPolicy
 			vmiSpec.IOThreadsPolicy = &(ioThreadsPolicy)
 		}
-		if reflect.DeepEqual(vmiSpec.IOThreadsPolicy, presetSpec.IOThreadsPolicy) {
+		if equality.Semantic.DeepEqual(vmiSpec.IOThreadsPolicy, presetSpec.IOThreadsPolicy) {
 			applied = true
 		}
 	}
diff --git a/pkg/virt-api/webhooks/mutating-webhook/mutators/vmi-mutator.go b/pkg/virt-api/webhooks/mutating-webhook/mutators/vmi-mutator.go
index d036b22be..0aef56240 100644
--- a/pkg/virt-api/webhooks/mutating-webhook/mutators/vmi-mutator.go
+++ b/pkg/virt-api/webhooks/mutating-webhook/mutators/vmi-mutator.go
@@ -23,12 +23,12 @@ import (
 	"encoding/json"
 	"fmt"
 	"net/http"
-	"reflect"
 	"strings"
 	"time"
 
 	admissionv1 "k8s.io/api/admission/v1"
 	k8sv1 "k8s.io/api/core/v1"
+	"k8s.io/apimachinery/pkg/api/equality"
 	"k8s.io/apimachinery/pkg/api/resource"
 	metav1 "k8s.io/apimachinery/pkg/apis/meta/v1"
 	"k8s.io/client-go/tools/cache"
@@ -180,7 +180,7 @@ func (mutator *VMIsMutator) Mutate(ar *admissionv1.AdmissionReview) *admissionv1
 		// Ignore status updates if they are not coming from our service accounts
 		// TODO: As soon as CRDs support field selectors we can remove this and just enable
 		// the status subresource. Until then we need to update Status and Metadata labels in parallel for e.g. Migrations.
-		if !reflect.DeepEqual(newVMI.Status, oldVMI.Status) {
+		if !equality.Semantic.DeepEqual(newVMI.Status, oldVMI.Status) {
 			if !webhooks.IsKubeVirtServiceAccount(ar.Request.UserInfo.Username) {
 				patch = append(patch, utiltypes.PatchOperation{
 					Op:    "replace",
diff --git a/pkg/virt-api/webhooks/mutating-webhook/mutators/vmi-mutator_test.go b/pkg/virt-api/webhooks/mutating-webhook/mutators/vmi-mutator_test.go
index 09179e576..05b974824 100644
--- a/pkg/virt-api/webhooks/mutating-webhook/mutators/vmi-mutator_test.go
+++ b/pkg/virt-api/webhooks/mutating-webhook/mutators/vmi-mutator_test.go
@@ -22,7 +22,6 @@ package mutators
 import (
 	"encoding/json"
 	"fmt"
-	"reflect"
 	rt "runtime"
 
 	. "github.com/onsi/ginkgo"
@@ -31,6 +30,7 @@ import (
 	admissionv1 "k8s.io/api/admission/v1"
 	v12 "k8s.io/api/authentication/v1"
 	k8sv1 "k8s.io/api/core/v1"
+	"k8s.io/apimachinery/pkg/api/equality"
 	"k8s.io/apimachinery/pkg/api/resource"
 	k8smetav1 "k8s.io/apimachinery/pkg/apis/meta/v1"
 	"k8s.io/apimachinery/pkg/runtime"
@@ -612,7 +612,7 @@ var _ = Describe("VirtualMachineInstance Mutator", func() {
 		err := webhooks.SetVirtualMachineInstanceHypervFeatureDependencies(vmi)
 		Expect(err).To(BeNil())
 		hyperv := v1.FeatureHyperv{}
-		ok := reflect.DeepEqual(*vmi.Spec.Domain.Features.Hyperv, hyperv)
+		ok := equality.Semantic.DeepEqual(*vmi.Spec.Domain.Features.Hyperv, hyperv)
 		if !ok {
 			// debug aid
 			fmt.Fprintf(GinkgoWriter, "got: %#v\n", *vmi.Spec.Domain.Features.Hyperv)
@@ -651,7 +651,7 @@ var _ = Describe("VirtualMachineInstance Mutator", func() {
 			},
 		}
 
-		ok := reflect.DeepEqual(*vmi.Spec.Domain.Features.Hyperv, hyperv)
+		ok := equality.Semantic.DeepEqual(*vmi.Spec.Domain.Features.Hyperv, hyperv)
 		if !ok {
 			// debug aid
 			fmt.Fprintf(GinkgoWriter, "got: %#v\n", *vmi.Spec.Domain.Features.Hyperv)
@@ -690,7 +690,7 @@ var _ = Describe("VirtualMachineInstance Mutator", func() {
 			},
 		}
 
-		ok := reflect.DeepEqual(*vmi.Spec.Domain.Features.Hyperv, hyperv)
+		ok := equality.Semantic.DeepEqual(*vmi.Spec.Domain.Features.Hyperv, hyperv)
 		if !ok {
 			// debug aid
 			fmt.Fprintf(GinkgoWriter, "got: %#v\n", *vmi.Spec.Domain.Features.Hyperv)
@@ -739,7 +739,7 @@ var _ = Describe("VirtualMachineInstance Mutator", func() {
 			},
 		}
 
-		ok := reflect.DeepEqual(*vmi.Spec.Domain.Features.Hyperv, hyperv)
+		ok := equality.Semantic.DeepEqual(*vmi.Spec.Domain.Features.Hyperv, hyperv)
 		if !ok {
 			// debug aid
 			fmt.Fprintf(GinkgoWriter, "got: %#v\n", *vmi.Spec.Domain.Features.Hyperv)
diff --git a/pkg/virt-api/webhooks/validating-webhook/admitters/BUILD.bazel b/pkg/virt-api/webhooks/validating-webhook/admitters/BUILD.bazel
index d9031092b..9a1361db4 100644
--- a/pkg/virt-api/webhooks/validating-webhook/admitters/BUILD.bazel
+++ b/pkg/virt-api/webhooks/validating-webhook/admitters/BUILD.bazel
@@ -43,6 +43,7 @@ go_library(
         "//vendor/k8s.io/api/admission/v1:go_default_library",
         "//vendor/k8s.io/api/authorization/v1:go_default_library",
         "//vendor/k8s.io/api/core/v1:go_default_library",
+        "//vendor/k8s.io/apimachinery/pkg/api/equality:go_default_library",
         "//vendor/k8s.io/apimachinery/pkg/api/errors:go_default_library",
         "//vendor/k8s.io/apimachinery/pkg/api/resource:go_default_library",
         "//vendor/k8s.io/apimachinery/pkg/apis/meta/v1:go_default_library",
@@ -103,6 +104,7 @@ go_test(
         "//vendor/k8s.io/api/admission/v1:go_default_library",
         "//vendor/k8s.io/api/authentication/v1:go_default_library",
         "//vendor/k8s.io/api/core/v1:go_default_library",
+        "//vendor/k8s.io/apimachinery/pkg/api/equality:go_default_library",
         "//vendor/k8s.io/apimachinery/pkg/api/errors:go_default_library",
         "//vendor/k8s.io/apimachinery/pkg/api/resource:go_default_library",
         "//vendor/k8s.io/apimachinery/pkg/apis/meta/v1:go_default_library",
diff --git a/pkg/virt-api/webhooks/validating-webhook/admitters/migration-update-admitter.go b/pkg/virt-api/webhooks/validating-webhook/admitters/migration-update-admitter.go
index db3293960..ab8d409d3 100644
--- a/pkg/virt-api/webhooks/validating-webhook/admitters/migration-update-admitter.go
+++ b/pkg/virt-api/webhooks/validating-webhook/admitters/migration-update-admitter.go
@@ -20,9 +20,8 @@
 package admitters
 
 import (
-	"reflect"
-
 	admissionv1 "k8s.io/api/admission/v1"
+	"k8s.io/apimachinery/pkg/api/equality"
 	metav1 "k8s.io/apimachinery/pkg/apis/meta/v1"
 
 	v1 "kubevirt.io/api/core/v1"
@@ -72,7 +71,7 @@ func (admitter *MigrationUpdateAdmitter) Admit(ar *admissionv1.AdmissionReview)
 	}
 
 	// Reject Migration update if spec changed
-	if !reflect.DeepEqual(newMigration.Spec, oldMigration.Spec) {
+	if !equality.Semantic.DeepEqual(newMigration.Spec, oldMigration.Spec) {
 		return webhookutils.ToAdmissionResponse([]metav1.StatusCause{
 			{
 				Type:    metav1.CauseTypeFieldValueNotSupported,
diff --git a/pkg/virt-api/webhooks/validating-webhook/admitters/vmi-update-admitter.go b/pkg/virt-api/webhooks/validating-webhook/admitters/vmi-update-admitter.go
index 28a239b1f..c50ce1e16 100644
--- a/pkg/virt-api/webhooks/validating-webhook/admitters/vmi-update-admitter.go
+++ b/pkg/virt-api/webhooks/validating-webhook/admitters/vmi-update-admitter.go
@@ -21,9 +21,9 @@ package admitters
 
 import (
 	"fmt"
-	"reflect"
 
 	admissionv1 "k8s.io/api/admission/v1"
+	"k8s.io/apimachinery/pkg/api/equality"
 	metav1 "k8s.io/apimachinery/pkg/apis/meta/v1"
 	k8sfield "k8s.io/apimachinery/pkg/util/validation/field"
 
@@ -50,7 +50,7 @@ func (admitter *VMIUpdateAdmitter) Admit(ar *admissionv1.AdmissionReview) *admis
 	}
 
 	// Reject VMI update if VMI spec changed
-	if !reflect.DeepEqual(newVMI.Spec, oldVMI.Spec) {
+	if !equality.Semantic.DeepEqual(newVMI.Spec, oldVMI.Spec) {
 		// Only allow the KubeVirt SA to modify the VMI spec, since that means it went through the sub resource.
 		if webhooks.IsKubeVirtServiceAccount(ar.Request.UserInfo.Username) {
 			hotplugResponse := admitHotplug(newVMI.Spec.Volumes, oldVMI.Spec.Volumes, newVMI.Spec.Domain.Devices.Disks, oldVMI.Spec.Domain.Devices.Disks, oldVMI.Status.VolumeStatus, newVMI, admitter.ClusterConfig)
@@ -116,7 +116,7 @@ func verifyHotplugVolumes(newHotplugVolumeMap, oldHotplugVolumeMap map[string]v1
 	for k, v := range newHotplugVolumeMap {
 		if _, ok := oldHotplugVolumeMap[k]; ok {
 			// New and old have same volume, ensure they are the same
-			if !reflect.DeepEqual(v, oldHotplugVolumeMap[k]) {
+			if !equality.Semantic.DeepEqual(v, oldHotplugVolumeMap[k]) {
 				return webhookutils.ToAdmissionResponse([]metav1.StatusCause{
 					{
 						Type:    metav1.CauseTypeFieldValueInvalid,
@@ -132,7 +132,7 @@ func verifyHotplugVolumes(newHotplugVolumeMap, oldHotplugVolumeMap map[string]v1
 					},
 				})
 			}
-			if !reflect.DeepEqual(newDisks[k], oldDisks[k]) {
+			if !equality.Semantic.DeepEqual(newDisks[k], oldDisks[k]) {
 				return webhookutils.ToAdmissionResponse([]metav1.StatusCause{
 					{
 						Type:    metav1.CauseTypeFieldValueInvalid,
@@ -196,7 +196,7 @@ func verifyPermanentVolumes(newPermanentVolumeMap, oldPermanentVolumeMap map[str
 				},
 			})
 		}
-		if !reflect.DeepEqual(v, oldPermanentVolumeMap[k]) {
+		if !equality.Semantic.DeepEqual(v, oldPermanentVolumeMap[k]) {
 			return webhookutils.ToAdmissionResponse([]metav1.StatusCause{
 				{
 					Type:    metav1.CauseTypeFieldValueInvalid,
@@ -204,7 +204,7 @@ func verifyPermanentVolumes(newPermanentVolumeMap, oldPermanentVolumeMap map[str
 				},
 			})
 		}
-		if !reflect.DeepEqual(newDisks[k], oldDisks[k]) {
+		if !equality.Semantic.DeepEqual(newDisks[k], oldDisks[k]) {
 			return webhookutils.ToAdmissionResponse([]metav1.StatusCause{
 				{
 					Type:    metav1.CauseTypeFieldValueInvalid,
@@ -270,7 +270,7 @@ func admitVMILabelsUpdate(
 	oldLabels := filterKubevirtLabels(oldVMI.ObjectMeta.Labels)
 	newLabels := filterKubevirtLabels(newVMI.ObjectMeta.Labels)
 
-	if !reflect.DeepEqual(oldLabels, newLabels) {
+	if !equality.Semantic.DeepEqual(oldLabels, newLabels) {
 		return webhookutils.ToAdmissionResponse([]metav1.StatusCause{
 			{
 				Type:    metav1.CauseTypeFieldValueNotSupported,
diff --git a/pkg/virt-api/webhooks/validating-webhook/admitters/vmi-update-admitter_test.go b/pkg/virt-api/webhooks/validating-webhook/admitters/vmi-update-admitter_test.go
index 896490c03..0b8cc1ff1 100644
--- a/pkg/virt-api/webhooks/validating-webhook/admitters/vmi-update-admitter_test.go
+++ b/pkg/virt-api/webhooks/validating-webhook/admitters/vmi-update-admitter_test.go
@@ -22,7 +22,6 @@ package admitters
 import (
 	"encoding/json"
 	"fmt"
-	"reflect"
 
 	. "github.com/onsi/ginkgo"
 	"github.com/onsi/ginkgo/extensions/table"
@@ -30,6 +29,7 @@ import (
 	"github.com/onsi/gomega/types"
 	admissionv1 "k8s.io/api/admission/v1"
 	authv1 "k8s.io/api/authentication/v1"
+	"k8s.io/apimachinery/pkg/api/equality"
 	metav1 "k8s.io/apimachinery/pkg/apis/meta/v1"
 	"k8s.io/apimachinery/pkg/runtime"
 
@@ -389,7 +389,7 @@ var _ = Describe("Validating VMIUpdate Admitter", func() {
 
 	table.DescribeTable("Should properly calculate the hotplugvolumes", func(volumes []v1.Volume, statuses []v1.VolumeStatus, expected map[string]v1.Volume) {
 		result := getHotplugVolumes(volumes, statuses)
-		Expect(reflect.DeepEqual(result, expected)).To(BeTrue(), "result: %v and expected: %v do not match", result, expected)
+		Expect(equality.Semantic.DeepEqual(result, expected)).To(BeTrue(), "result: %v and expected: %v do not match", result, expected)
 	},
 		table.Entry("Should be empty if statuses is empty", makeVolumes(), makeStatus(0, 0), emptyResult()),
 		table.Entry("Should be empty if statuses has multiple entries, but no hotplug", makeVolumes(), makeStatus(2, 0), emptyResult()),
@@ -400,7 +400,7 @@ var _ = Describe("Validating VMIUpdate Admitter", func() {
 
 	table.DescribeTable("Should properly calculate the permanent volumes", func(volumes []v1.Volume, statusVolumes []v1.VolumeStatus, expected map[string]v1.Volume) {
 		result := getPermanentVolumes(volumes, statusVolumes)
-		Expect(reflect.DeepEqual(result, expected)).To(BeTrue(), "result: %v and expected: %v do not match", result, expected)
+		Expect(equality.Semantic.DeepEqual(result, expected)).To(BeTrue(), "result: %v and expected: %v do not match", result, expected)
 	},
 		table.Entry("Should be empty if volume is empty", makeVolumes(), makeStatus(0, 0), emptyResult()),
 		table.Entry("Should be empty if all volumes are hotplugged", makeVolumes(0, 1, 2, 3), makeStatus(4, 4), emptyResult()),
@@ -415,7 +415,7 @@ var _ = Describe("Validating VMIUpdate Admitter", func() {
 		newVMI.Spec.Domain.Devices.Disks = newDisks
 
 		result := admitHotplug(newVolumes, oldVolumes, newDisks, oldDisks, volumeStatuses, newVMI, vmiUpdateAdmitter.ClusterConfig)
-		Expect(reflect.DeepEqual(result, expected)).To(BeTrue(), "result: %v and expected: %v do not match", result, expected)
+		Expect(equality.Semantic.DeepEqual(result, expected)).To(BeTrue(), "result: %v and expected: %v do not match", result, expected)
 	},
 		table.Entry("Should accept if no volumes are there or added",
 			makeVolumes(),
diff --git a/pkg/virt-api/webhooks/validating-webhook/admitters/vmpool-admitter.go b/pkg/virt-api/webhooks/validating-webhook/admitters/vmpool-admitter.go
index 0758c0813..1d9c8b2b0 100644
--- a/pkg/virt-api/webhooks/validating-webhook/admitters/vmpool-admitter.go
+++ b/pkg/virt-api/webhooks/validating-webhook/admitters/vmpool-admitter.go
@@ -22,9 +22,9 @@ package admitters
 import (
 	"encoding/json"
 	"fmt"
-	"reflect"
 
 	admissionv1 "k8s.io/api/admission/v1"
+	"k8s.io/apimachinery/pkg/api/equality"
 	metav1 "k8s.io/apimachinery/pkg/apis/meta/v1"
 	"k8s.io/apimachinery/pkg/labels"
 	"k8s.io/apimachinery/pkg/runtime/schema"
@@ -124,7 +124,7 @@ func ValidateVMPoolSpec(ar *admissionv1.AdmissionReview, field *k8sfield.Path, p
 			})
 		}
 
-		if !reflect.DeepEqual(pool.Spec.Selector, oldPool.Spec.Selector) {
+		if !equality.Semantic.DeepEqual(pool.Spec.Selector, oldPool.Spec.Selector) {
 			causes = append(causes, metav1.StatusCause{
 				Type:    metav1.CauseTypeFieldValueInvalid,
 				Message: fmt.Sprintf("selector is immutable after creation."),
